install 58 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734735736737738739740741742743744745746747748749750751752753754755756757758759760761762763764765766767768769770771772773774775776777778779780781782783784785786787788789790791792793794795796797798799800801802803804805806807808809810811812813814815816817818819820821822823824825826827828829830831832833834835836837838839840841842843844845846847848849850851852853854855856857858859860861862863864865866867868869870871872873874875876877878879880881882883884885886887888889890891892893894895896897898899900901902903904905906907908909910911912913914915916917918919920921922923924925926927928929930931932933934935936937938939940941942943944945946947948949950951952953954955956957958959960961962963964965966967968969970971972973974975976977978979980981982983984985986987988989990991992993994995996997998999100010011002100310041005100610071008100910101011101210131014101510161017101810191020102110221023102410251026102710281029103010311032103310341035103610371038103910401041104210431044104510461047104810491050105110521053105410551056105710581059106010611062106310641065106610671068106910701071107210731074107510761077107810791080108110821083108410851086108710881089109010911092109310941095109610971098109911001101110211031104110511061107110811091110111111121113111411151116111711181119112011211122112311241125112611271128112911301131113211331134113511361137113811391140114111421143114411451146114711481149115011511152115311541155115611571158115911601161116211631164116511661167116811691170117111721173117411751176117711781179118011811182118311841185118611871188118911901191119211931194119511961197119811991200120112021203120412051206120712081209121012111212121312141215121612171218121912201221122212231224122512261227122812291230123112321233123412351236123712381239124012411242124312441245124612471248124912501251125212531254125512561257125812591260126112621263126412651266126712681269127012711272127312741275127612771278127912801281128212831284128512861287128812891290129112921293129412951296129712981299130013011302130313041305130613071308130913101311131213131314131513161317131813191320132113221323132413251326132713281329133013311332133313341335133613371338133913401341134213431344134513461347134813491350135113521353135413551356135713581359136013611362136313641365136613671368136913701371137213731374137513761377137813791380138113821383138413851386138713881389139013911392139313941395139613971398139914001401140214031404140514061407140814091410141114121413141414151416141714181419142014211422142314241425142614271428142914301431143214331434143514361437143814391440144114421443144414451446144714481449145014511452145314541455145614571458145914601461146214631464146514661467146814691470147114721473147414751476147714781479148014811482148314841485148614871488148914901491149214931494149514961497149814991500150115021503150415051506150715081509151015111512151315141515151615171518151915201521152215231524152515261527152815291530153115321533153415351536153715381539154015411542154315441545154615471548154915501551155215531554155515561557155815591560156115621563156415651566156715681569157015711572157315741575157615771578157915801581158215831584158515861587158815891590159115921593159415951596159715981599160016011602160316041605160616071608160916101611161216131614161516161617161816191620162116221623162416251626162716281629163016311632163316341635163616371638163916401641164216431644164516461647164816491650165116521653165416551656165716581659166016611662166316641665166616671668166916701671167216731674167516761677167816791680168116821683168416851686168716881689169016911692169316941695169616971698169917001701170217031704170517061707170817091710171117121713171417151716171717181719172017211722172317241725172617271728172917301731173217331734173517361737173817391740174117421743174417451746174717481749175017511752175317541755
  1. #!/bin/bash
  2. #################################################################
  3. # auto-mediawiki #
  4. # Instala un servidor LAMP (Linux+Apache+MySQL+PHP) e instala #
  5. # MediaWiki y lo configura. #
  6. # #
  7. # Guzman Castanedo Villalba (guzman@castanedo.es) Junio 2018 #
  8. # GPLv3 (https://www.gnu.org/licenses/gpl.html) #
  9. #################################################################
  10. comprobarError() {
  11. # comprobarError exitNum codeNum extraInfo
  12. # 1xx: Servidor Web
  13. # 2xx: Base de Datos
  14. # 3xx: PHP
  15. # 4xx: SSL/TLS
  16. # 5xx: MediaWiki
  17. # 6xx: Moodle
  18. # 7xx: Actualizaciones automáticas
  19. # 8xx: Dependencias
  20. # 9xx: Servicios & Firewall
  21. type="ERROR"
  22. exitNum=$1
  23. shift
  24. codeNum=$1
  25. shift
  26. extraInfo=$@
  27. case $codeNum in
  28. 1)
  29. error="$type $codeNum:\tInstalación interrumpida por el usuario.\n"
  30. ;;
  31. 2)
  32. error="$type $codeNum:\tError interno (selección express).\n"
  33. ;;
  34. 3)
  35. error="$type $codeNum:\tError interno (selección avanzada).\n"
  36. ;;
  37. 4)
  38. error="\n$type $codeNum:\tEl archivo '"$(realpath $extraInfo)"' no existe.\n"
  39. ;;
  40. 5)
  41. error="\n$type $codeNum:\tEl directorio '"$(realpath $extraInfo)"' no existe.\n"
  42. ;;
  43. 6)
  44. error="$type $codeNum:\tError interno (selección SSL/TLS).\n"
  45. ;;
  46. 100)
  47. error="$type $codeNum:\tError interno (selección del servidor web).\n"
  48. ;;
  49. 101)
  50. error="\n$type $codeNum:\tError al instalar Apache2.\nDetalles:\n$extraInfo\n"
  51. ;;
  52. 102)
  53. error="\n$type $codeNum:\tError al instalar Nginx.\nDetalles:\n$extraInfo\n"
  54. ;;
  55. 103)
  56. error="\n$type $codeNum:\tError al nstalar repositorio 'epel-release'.\nDetalles:\n$extraInfo\n"
  57. ;;
  58. 104)
  59. error="\n$type $codeNum:\tError interno (instalación Apache2).\n"
  60. ;;
  61. 105)
  62. error="\n$type $codeNum:\tError interno (instalación Nginx).\n"
  63. ;;
  64. 106)
  65. type="WARNING"
  66. error="\n$type $codeNum:\tImposible instalar 'info.php'.\n"
  67. ;;
  68. 107)
  69. error="\n$type $codeNum:\tError al configurar Nginx.\n"
  70. ;;
  71. 108)
  72. error="\n$type $codeNum:\tError al configurar Apache2.\n"
  73. ;;
  74. 200)
  75. error="$type $codeNum:\tError interno (selección de base de datos).\n"
  76. ;;
  77. 201)
  78. error="\n$type $codeNum:\tError al instalar MySQL.\nDetalles:\n$extraInfo\n"
  79. ;;
  80. 202)
  81. error="\n$type $codeNum:\tError al instalar MariaDB.\nDetalles:\n$extraInfo\n"
  82. ;;
  83. 203)
  84. error="\n$type $codeNum:\tError interno (instalación MySQL).\n"
  85. ;;
  86. 204)
  87. error="\n$type $codeNum:\tError interno (instalación MariaDB).\n"
  88. ;;
  89. 205)
  90. error="\n$type $codeNum:\t$DIST no incluye MySQL en sus repositorios.\n"
  91. ;;
  92. 206)
  93. type="WARNING"
  94. error="\n$type $codeNum:\tUsuario 'root' ya dispone de contraseña."
  95. ;;
  96. 207)
  97. error="\n$type $codeNum:\tImposible cambiar la contraseña de 'root'."
  98. ;;
  99. 208)
  100. error="\n$type $codeNum:\tImposible desactivar acceso 'root' desde el exterior."
  101. ;;
  102. 209)
  103. error="\n$type $codeNum:\tImposible eliminar usuarios anónimos."
  104. ;;
  105. 210)
  106. type="WARNING"
  107. error="\n$type $codeNum:\tImposible eliminar bases de datos de pruebas."
  108. ;;
  109. 211)
  110. type="WARNING"
  111. error="\n$type $codeNum:\tImposible eliminar los permisos de las bases de datos de pruebas."
  112. ;;
  113. 212)
  114. error="\n$type $codeNum:\tImposible recargar base de datos."
  115. ;;
  116. 213)
  117. error="\n$type $codeNum:\tImposible configurar SQL.\n"
  118. ;;
  119. 214)
  120. type="WARNING"
  121. error="\n$type $codeNum:\tSQL ya está configurado."
  122. ;;
  123. 300)
  124. error="\n$type $codeNum:\tError interno (instalación PHP-7.2).\n"
  125. ;;
  126. 301)
  127. error="\n$type $codeNum:\tError interno (Web Server no seleccionado).\n"
  128. ;;
  129. 302)
  130. error="\n$type $codeNum:\tError al instalar PHP-7.2.\nDetalles:\n$extraInfo\n"
  131. ;;
  132. 303)
  133. error="\n$type $codeNum:\tError al instalar Repositorio Remi.\nDetalles:\n$extraInfo\n"
  134. ;;
  135. 304)
  136. error="\n$type $codeNum:\tSistema Operativo no compatible con PHP-7.2 ($OS $DIST $REV).\n"
  137. ;;
  138. 305)
  139. error="\n$type $codeNum:\tImposible configurar PHP-7.2.\n"
  140. ;;
  141. 501)
  142. error="\n$type $codeNum:\tImposible descargar MediaWiki-1.31.0.\n"
  143. ;;
  144. 502)
  145. error="\n$type $codeNum:\tImposible configurar MediaWiki-1.31.0.\n"
  146. ;;
  147. 503)
  148. type="WARNING"
  149. error="\n$type $codeNum:\tYa existe una copia configurada de MediaWiki en el dominio: '$extraInfo'."
  150. ;;
  151. 601)
  152. error="\n$type $codeNum:\tImposible descargar Moodle-3.5.1.\n"
  153. ;;
  154. 602)
  155. error="\n$type $codeNum:\tImposible configurar Moodle-3.5.1.\n"
  156. ;;
  157. 603)
  158. type="WARNING"
  159. error="\n$type $codeNum:\tYa existe una copia configurada de Moodle en el dominio: '$extraInfo'."
  160. ;;
  161. 604)
  162. error="\n$type $codeNum:\tImposible configurar SELinux.\n"
  163. ;;
  164. 605)
  165. error="\n$type $codeNum:\tImposible instalar 'policycoreutils-python'.Detalles:\n$extraInfo\n"
  166. ;;
  167. 800)
  168. error="$type $codeNum:\tEs necesario ser root ('sudo $0').\n"
  169. ;;
  170. 801)
  171. error="$type $codeNum:\t'whiptail' no instalado.\n"
  172. ;;
  173. 802)
  174. error="$type $codeNum:\t'hostnamectl' no instalado.\n"
  175. ;;
  176. 803)
  177. error="$type $codeNum:\t'apt-get' no instalado.\n"
  178. ;;
  179. 804)
  180. error="$type $codeNum:\t'yum' no instalado.\n"
  181. ;;
  182. 805)
  183. error="\n$type $codeNum:\tImposible actualizar repositorio\nDetalles:\n$extraInfo.\n"
  184. ;;
  185. 806)
  186. error="$type $codeNum:\t'ufw' no instalado.\n"
  187. ;;
  188. 807)
  189. error="$type $codeNum:\t'firewall-cmd' no instalado.\n"
  190. ;;
  191. 808)
  192. error="$type $codeNum:\t'tput' no instalado.\nDetalles:\n$extraInfo\n"
  193. ;;
  194. 809)
  195. error="$type $codeNum:\t'sed' no instalado.\nDetalles:\n$extraInfo\n"
  196. ;;
  197. 810)
  198. error="$type $codeNum:\t'curl' no instalado.\nDetalles:\n$extraInfo\n"
  199. ;;
  200. 811)
  201. error="$type $codeNum:\t'tar' no instalado.\nDetalles:\n$extraInfo\n"
  202. ;;
  203. 812)
  204. error="$type $codeNum:\t'gzip' no instalado.\nDetalles:\n$extraInfo\n"
  205. ;;
  206. 813)
  207. error="$type $codeNum:\t'bzip2' no instalado.\nDetalles:\n$extraInfo\n"
  208. ;;
  209. 814)
  210. error="$type $codeNum:\t'xz' no instalado.\nDetalles:\n$extraInfo\n"
  211. ;;
  212. 815)
  213. error="$type $codeNum:\t'openssl' no instalado.\nDetalles:\n$extraInfo\n"
  214. ;;
  215. 816)
  216. error="$type $codeNum:\t'find' no instalado.\n"
  217. ;;
  218. 900)
  219. error="$type $codeNum:\tError interno (habilitar servicio).\n"
  220. ;;
  221. 901)
  222. error="$type $codeNum:\tImposible encender servicio '$extraInfo'.\n"
  223. ;;
  224. 902)
  225. error="$type $codeNum:\tImposible habilitar servicio '$extraInfo' durante el arranque.\n"
  226. ;;
  227. 903)
  228. error="$type $codeNum:\tError interno (deshabilitar servicio).\n"
  229. ;;
  230. 904)
  231. error="$type $codeNum:\tImposible parar servicio '$extraInfo'.\n"
  232. ;;
  233. 905)
  234. error="$type $codeNum:\tImposible deshabilitar servicio '$extraInfo' durante el arranque.\n"
  235. ;;
  236. 906)
  237. type="WARNING"
  238. error="\n$type $codeNum:\tImposible añadir regla al cortafuegos ('$extraInfo').\n"
  239. ;;
  240. 907)
  241. type="WARNING"
  242. error="\n$type $codeNum:\tImposible encender cortafuegos.\n"
  243. ;;
  244. 908)
  245. error="\n$type $codeNum:\tError interno (instalar Virtual Host).\n"
  246. ;;
  247. 909)
  248. error="\n$type $codeNum:\tVirtual Host '$extraInfo' no existe.\n"
  249. ;;
  250. 910)
  251. error="\n$type $codeNum:\tImposible copiar Virtual Host '$extraInfo'.\n"
  252. ;;
  253. 911)
  254. error="\n$type $codeNum:\tImposible activar Virtual Host '$extraInfo'.\n"
  255. ;;
  256. 912)
  257. error="\n$type $codeNum:\tError interno (recargar servicio).\n"
  258. ;;
  259. 913)
  260. error="\n$type $codeNum:\tImposible recargar servicio '$extraInfo'.\n"
  261. ;;
  262. *)
  263. error="ERROR 13:\tError interno (comprobación de errores)\n"
  264. exitNum=1
  265. codeNum=13
  266. ;;
  267. esac
  268. if [ $exitNum -ne 0 ];then
  269. echo -en "$error" | tee -a $logFile
  270. if [ $type = "ERROR" ];then
  271. exit $codeNum
  272. fi
  273. fi
  274. unset error exitNum codeNum type
  275. }
  276. OSInfo() {
  277. echo -en "Detectando SO..." >> $logFile
  278. OS=$(uname -s)
  279. if [ $OS = "Linux" ]; then
  280. OS="GNU/Linux"
  281. if [ -f /etc/os-release ]; then
  282. DIST=$(grep ^NAME= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  283. REV=$(grep ^VERSION= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  284. ID_LIKE=$(grep ^ID_LIKE= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  285. VERSION=$(grep ^VERSION_ID= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  286. for i in $ID_LIKE; do
  287. #echo -en "$i\n"
  288. case $i in
  289. debian|ubuntu)
  290. debianOS=true
  291. break
  292. ;;
  293. rhel|fedora)
  294. rhelOS=true
  295. break
  296. ;;
  297. *)
  298. debianOS=false
  299. rhelOS=false
  300. ;;
  301. esac
  302. done
  303. elif [ -f /etc/debian-version ]; then
  304. # Familia Debian (Debian, Ubuntu, Linux Mint, ...)
  305. DIST="Debian"
  306. REV=""
  307. ID_LIKE="debian"
  308. VERSION=""
  309. debianOS=true
  310. elif [ -f /etc/redhat-release ]; then
  311. # Familia Red-Hat (RHEL, Fedora, CentOS, ...)
  312. DIST="Red-Hat"
  313. REV=""
  314. ID_LIKE="rhel"
  315. VERSION=""
  316. rhelOS=true
  317. else
  318. # Other Linux (No Soportado)
  319. DIST=""
  320. REV=""
  321. ID_LIKE=""
  322. VERSION=""
  323. fi
  324. else
  325. # UNIX, OS X, ... (No Soportado)
  326. DIST=$OS
  327. REV=""
  328. ID_LIKE=""
  329. VERSION=""
  330. fi
  331. echo -en " $OS $DIST $REV\n" >> $logFile
  332. HDInfo=$(df -h | head -1)"\n"$(df -h | grep ^/dev/sd)"\n"$(df -h | grep ^/dev/mapper)
  333. echo -en "$HDInfo\n" >> $logFile
  334. }
  335. comprobarRoot() {
  336. comprobarError $(id -u) 800
  337. }
  338. comprobarDependencias() {
  339. # Comprobamos whiptail
  340. which whiptail > /dev/null 2>&1
  341. comprobarError $? 801
  342. # Comprobamos hostnamectl
  343. which hostnamectl > /dev/null 2>&1
  344. comprobarError $? 802
  345. which find > /dev/null 2>&1
  346. comprobarError $? 816
  347. if [ $debianOS = true ];then
  348. # Comprobamos apt-get
  349. which apt-get > /dev/null 2>&1
  350. comprobarError $? 803
  351. # Actualizamos base de datos del repositorio
  352. echo -en "Actualizando repositorio APT..." | tee -a $logFile
  353. result=$(apt-get -q -y update 2>&1)
  354. comprobarError $? 805 $result
  355. echo -en " OK.\n" | tee -a $logFile
  356. # Comprobamos Firewall (ufw)
  357. which ufw > /dev/null 2>&1
  358. comprobarError $? 806
  359. # Comprobamos tput
  360. which tput > /dev/null 2>&1
  361. if [ $? -ne 0 ];then
  362. result=$(apt-get -q -y ncurses-bin 2>&1)
  363. comprobarError $? 808 $result
  364. fi
  365. # Comprobar sed
  366. which sed > /dev/null 2>&1
  367. if [ $? -ne 0 ];then
  368. result=$(apt-get -q -y sed 2>&1)
  369. comprobarError $? 809 $result
  370. fi
  371. # Comprobar curl
  372. which curl > /dev/null 2>&1
  373. if [ $? -ne 0 ];then
  374. result=$(apt-get -q -y curl 2>&1)
  375. comprobarError $? 810 $result
  376. fi
  377. # Comprobamos tar, gzip, bzip2 y xz
  378. which tar > /dev/null 2>&1
  379. if [ $? -ne 0 ];then
  380. result=$(apt-get -q -y install tar 2>&1)
  381. comprobarError $? 811 $result
  382. fi
  383. which gzip > /dev/null 2>&1
  384. if [ $? -ne 0 ];then
  385. result=$(apt-get -q -y install gzip 2>&1)
  386. comprobarError $? 812 $result
  387. fi
  388. which bzip2 > /dev/null 2>&1
  389. if [ $? -ne 0 ];then
  390. result=$(apt-get -q -y install bzip2 2>&1)
  391. comprobarError $? 813 $result
  392. fi
  393. which xz > /dev/null 2>&1
  394. if [ $? -ne 0 ];then
  395. result=$(apt-get -q -y install xz-utils 2>&1)
  396. comprobarError $? 814 $result
  397. fi
  398. which openssl > /dev/null 2>&1
  399. if [ $? -ne 0 ];then
  400. result=$(apt-get -q -y install openssl 2>&1)
  401. comprobarError $? 815 $result
  402. fi
  403. fi
  404. if [ $rhelOS = true ]; then
  405. # Comprobamos yum
  406. which yum > /dev/null 2>&1
  407. comprobarError $? 804
  408. # Actualizamos base de datos del repositorio
  409. echo -en "Actualizando repositorio YUM..." | tee -a $logFile
  410. result=$(yum -y makecache 2>&1)
  411. comprobarError $? 805 $result
  412. echo -en " OK.\n" | tee -a $logFile
  413. # Comprobamos Firewall (firewall-cmd)
  414. which firewall-cmd > /dev/null 2>&1
  415. comprobarError $? 807
  416. # Comprobamos tput
  417. which tput > /dev/null 2>&1
  418. if [ $? -ne 0 ];then
  419. result=$(yum -y ncurses 2>&1)
  420. comprobarError $? 808 $result
  421. fi
  422. # Comprobar sed
  423. which sed > /dev/null 2>&1
  424. if [ $? -ne 0 ];then
  425. result=$(yum -y sed 2>&1)
  426. comprobarError $? 809 $result
  427. fi
  428. # Comprobar curl
  429. which curl > /dev/null 2>&1
  430. if [ $? -ne 0 ];then
  431. result=$(yum -y curl 2>&1)
  432. comprobarError $? 810 $result
  433. fi
  434. # Comprobamos tar, gzip, bzip2 y xz
  435. which tar > /dev/null 2>&1
  436. if [ $? -ne 0 ];then
  437. result=$(yum -y install tar 2>&1)
  438. comprobarError $? 811 $result
  439. fi
  440. which gzip > /dev/null 2>&1
  441. if [ $? -ne 0 ];then
  442. result=$(yum -y install gzip 2>&1)
  443. comprobarError $? 812 $result
  444. fi
  445. which bzip2 > /dev/null 2>&1
  446. if [ $? -ne 0 ];then
  447. result=$(yum -y install bzip2 2>&1)
  448. comprobarError $? 813 $result
  449. fi
  450. which xz > /dev/null 2>&1
  451. if [ $? -ne 0 ];then
  452. result=$(yum -y install xz 2>&1)
  453. comprobarError $? 814 $result
  454. fi
  455. which openssl > /dev/null 2>&1
  456. if [ $? -ne 0 ];then
  457. result=$(yum -y install openssl 2>&1)
  458. comprobarError $? 815 $result
  459. fi
  460. fi
  461. }
  462. inicializarVariables() {
  463. debianOS=false
  464. rhelOS=false
  465. apacheOn=false
  466. nginxOn=false
  467. mySQLOn=false
  468. mariaDBOn=false
  469. phpOn=false
  470. sslOn=false
  471. letsEncryptOn=false
  472. mediaWikiOn=false
  473. moodleOn=false
  474. infoPHPOn=false
  475. actualizacionesOn=false
  476. progreso=0
  477. progresoTotal=0
  478. hostname=""
  479. logFile="./."$(basename $0)".log"
  480. maxUpload="100M"
  481. webServerName=""
  482. webServerUser=""
  483. webServerGroup=""
  484. sqlServerName=""
  485. phpFPMName=""
  486. nombreMediaWiki=""
  487. dominioMediaWiki=""
  488. passwdMediaWiki=""
  489. nombreMoodle=""
  490. nombreCortoMoodle=""
  491. dominioMoodle=""
  492. passwdMoodle=""
  493. }
  494. instalacionExpress() {
  495. apacheOn=true
  496. mariaDBOn=true
  497. phpOn=true
  498. sslOn=true
  499. letsEncryptOn=true
  500. mediaWikiOn=true
  501. moodleOn=true
  502. actualizacionesOn=true
  503. progresoTotal=15
  504. # Preguntas mínimas
  505. establecerFQDN
  506. leerSQLPasswd
  507. mostrarMediaWiki
  508. mostrarMoodle
  509. }
  510. mostrarBienvenida() {
  511. ANCHO=$(tput cols)
  512. ALTO=$(tput lines)
  513. if [ $debianOS = false ] && [ $rhelOS = false ]; then
  514. whiptail --title "ERROR S.O. NO SOPORTADO" --msgbox "Este script automatiza la creación de una web MediaWiki SOLO para distribuciones Linux de la familia Debian (Ubuntu, Linux Mint, ...) y de la familia Red-Hat (CentOS, Fedora, ...).\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Salir"
  515. exit 1
  516. fi
  517. whiptail --title "INSTALACION MEDIAWIKI" --yesno "Este script automatiza completamente la instalación de una wiki.\nPara ello instala un servidor LAMP, el software MediaWiki y lo configura todo.\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --yes-button "Continuar" --no-button "Salir"
  518. comprobarError $? 1
  519. }
  520. mostrarExpress() {
  521. express=$(whiptail --title "INSTALACION EXPRESS" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nLa instalación express instala Apache2, MariaDB, PHP-7, Let's Encrypt, MediaWiki, Moodle y actualizaciones automáticas.\nSeleccione el tipo de instalación que desee:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) 2 \
  522. "Express" "Instalación rápida" ON \
  523. "Avanzada" "Permite escoger todas las opciones disponibles" OFF \
  524. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  525. comprobarError $? 1
  526. case $express in
  527. Express)
  528. instalacionExpress
  529. # DECIDIR QUÉ OPCIONES SON LAS MÍNIMAS
  530. ;;
  531. Avanzada)
  532. mostrarAvanzada
  533. ;;
  534. *)
  535. comprobarError 1 2
  536. ;;
  537. esac
  538. unset express
  539. }
  540. mostrarAvanzada() {
  541. webServer=$(whiptail --title "INSTALACION AVANZADA" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge el tipo de Servidor Web que quieres instalar:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) 2 \
  542. "LAMP" "GNU/Linux + Apache + MySQL/MariaDB + PHP-7" ON \
  543. "LEMP" "GNU/Linux + Nginx + MySQL/MariaDB + PHP-7" OFF \
  544. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  545. comprobarError $? 1
  546. for i in $webServer; do
  547. case $i in
  548. LAMP)
  549. apacheOn=true
  550. ;;
  551. LEMP)
  552. nginxOn=true
  553. ;;
  554. *)
  555. comprobarError 1 100
  556. ;;
  557. esac
  558. done
  559. # Opciones comunes
  560. establecerFQDN
  561. mostrarDatabase
  562. phpOn=true
  563. establecerMaxUpload
  564. progresoTotal=$((progresoTotal + 6))
  565. mostrarComponentes
  566. unset webServer
  567. }
  568. mostrarComponentes() {
  569. componentes=$(whiptail --title "INSTALACION AVANZADA" --checklist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge los componentes que quieres instalar:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) 5 \
  570. "SSL/TLS" "Instalar certificados para activar HTTPS" ON \
  571. "MediaWiki" "Instalar wiki con MediaWiki" ON \
  572. "Moodle" "Instalar campus virtual con Moodle" ON \
  573. "InfoPHP" "Instalar info.php (sólo para pruebas)" OFF \
  574. "Actualizaciones" "Programar actualizaciones automáticas" ON \
  575. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  576. comprobarError $? 1
  577. # Mejora: autodetección de componentes ya instalados
  578. for i in $componentes; do
  579. case $i in
  580. \"SSL/TLS\")
  581. # 2 Opciones: Let's Encrypt o Autofirmado
  582. mostrarSSL
  583. progresoTotal=$((progresoTotal + 2))
  584. ;;
  585. \"MediaWiki\")
  586. mediaWikiOn=true
  587. mostrarMediaWiki
  588. progresoTotal=$((progresoTotal + 2))
  589. ;;
  590. \"Moodle\")
  591. moodleOn=true
  592. mostrarMoodle
  593. progresoTotal=$((progresoTotal + 2))
  594. ;;
  595. \"InfoPHP\")
  596. infoPHPOn=true
  597. progresoTotal=$((progresoTotal + 2))
  598. ;;
  599. \"Actualizaciones\")
  600. actualizacionesOn=true
  601. progresoTotal=$((progresoTotal + 1))
  602. ;;
  603. *)
  604. comprobarError 1 3
  605. ;;
  606. esac
  607. done
  608. progresoTotal=$((progresoTotal + 2))
  609. unset componentes
  610. }
  611. mostrarSSL() {
  612. ssl=$(whiptail --title "INSTALACION SSL/TLS" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge el tipo de Certificado SSL/TLS que quieres instalar:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) 2 \
  613. "LetsEncrypt" "Compatible con todos los navegadores" ON \
  614. "Auto-Firmado" "Certificados auto-firmados (sólo para pruebas)" OFF \
  615. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  616. comprobarError $? 1
  617. for i in $ssl; do
  618. case $i in
  619. LetsEncrypt)
  620. sslOn=true
  621. letsEcnryptOn=true
  622. ;;
  623. Auto-Firmados)
  624. sslOn=true
  625. ;;
  626. *)
  627. comprobarError 1 6
  628. ;;
  629. esac
  630. done
  631. unset ssl
  632. }
  633. mostrarMediaWiki(){
  634. # Introducir nombre wiki
  635. while [ -z "$nombreMediaWiki" ]; do
  636. nombreMediaWiki=$(whiptail --title "CONFIGURACION MEDIAWIKI" --inputbox "Introduzca el nombre de la Wiki:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  637. comprobarError $? 1
  638. done
  639. # Introducir dominio
  640. while [ -z "$dominioMediaWiki" ]; do
  641. dominioMediaWiki=$(whiptail --title "CONFIGURACION MEDIAWIKI" --inputbox "Introduzca el dominio/subdominio de la Wiki.\nTenga en cuenta que debes apuntar este dominio a la dirección IP de esta máquina mediante un registro DNS de tipo CNAME.\nSi quiere introducir varios dominios sepárelos con espacios. El primero será el principal.\nPor ejemplo: 'www.$hostname $hostname wiki.$hostname'" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) wiki.$hostname --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  642. comprobarError $? 1
  643. done
  644. cont=1
  645. serverName=""
  646. aliasMediaWiki=""
  647. for dominio in $dominioMediaWiki;do
  648. if [ $cont -eq 1 ];then
  649. # Dominio Principal (ServerName)
  650. serverName=$dominio
  651. else
  652. # Dominios Secundarios (ServerAlias)
  653. aliasMediaWiki=$aliasMediaWiki" "$dominio
  654. fi
  655. cont=$((cont + 1))
  656. done
  657. dominioMediaWiki=$serverName
  658. # Introducir contraseña
  659. control=false
  660. error=""
  661. while [ $control = false ]; do
  662. passwdMediaWiki=$(whiptail --title "CONFIGURACION MEDIAWIKI" --passwordbox "$error""Introduzca la contraseña para el usuario administrador 'admin':" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Continuar" --nocancel 3>&1 1>&2 2>&3)
  663. comprobarError $? 1
  664. passwdMediaWiki2=$(whiptail --title "CONFIGURACION MEDIAWIKI" --passwordbox "Confirme la contraseña:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Continuar" --nocancel 3>&1 1>&2 2>&3)
  665. comprobarError $? 1
  666. if [ -z "$passwdMediaWiki" ] || [ -z "$passwdMediaWiki2" ]; then
  667. error="ERROR: LA CONTRASEÑA NO PUEDE ESTAR VACIA.\n"
  668. elif [ $passwdMediaWiki != $passwdMediaWiki2 ];then
  669. error="ERROR: LAS CONTRASEÑAS NO COINCIDEN.\n"
  670. else
  671. control=true
  672. fi
  673. done
  674. unset control error passwdMediaWiki2 dominio cont serverName
  675. }
  676. mostrarMoodle() {
  677. # Introducir Nombre Moodle
  678. while [ -z "$nombreMoodle" ]; do
  679. nombreMoodle=$(whiptail --title "CONFIGURACION MOODLE" --inputbox "Introduzca el NOMBRE COMPLETO del campus virtual.\nPor ejemplo: 'Campus Virtual Ejemplo'." $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  680. comprobarError $? 1
  681. done
  682. # Introducir Nombre Corto Moodle
  683. while [ -z "$nombreCortoMoodle" ]; do
  684. nombreCortoMoodle=$(whiptail --title "CONFIGURACION MOODLE" --inputbox "Introduzca el NOMBRE CORTO del campus virtual.\nPor ejemplo: 'Ejemplo'." $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  685. comprobarError $? 1
  686. done
  687. # Introducir dominio
  688. while [ -z "$dominioMoodle" ]; do
  689. dominioMoodle=$(whiptail --title "CONFIGURACION MOODLE" --inputbox "Introduzca el dominio/subdominio del campus virtual.\nMoodle SÓLO permite un ÚNICO DOMINIO." $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) moodle.$hostname --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  690. comprobarError $? 1
  691. done
  692. cont=1
  693. serverName=""
  694. aliasMoodle=""
  695. for dominio in $dominioMoodle;do
  696. if [ $cont -eq 1 ];then
  697. # Dominio Principal (ServerName)
  698. serverName=$dominio
  699. else
  700. # Dominios Secundarios (ServerAlias)
  701. aliasMeoodle=$aliasMoodle" "$dominio
  702. fi
  703. cont=$((cont + 1))
  704. done
  705. dominioMoodle=$serverName
  706. # Introducir contraseña
  707. control=false
  708. error=""
  709. while [ $control = false ]; do
  710. passwdMoodle=$(whiptail --title "CONFIGURACION MOODLE" --passwordbox "$error""Introduzca la contraseña para el usuario administrador 'admin':" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Continuar" --nocancel 3>&1 1>&2 2>&3)
  711. comprobarError $? 1
  712. passwdMoodle2=$(whiptail --title "CONFIGURACION MOODLE" --passwordbox "Confirme la contraseña:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Continuar" --nocancel 3>&1 1>&2 2>&3)
  713. comprobarError $? 1
  714. if [ -z "$passwdMoodle" ] || [ -z "$passwdMoodle2" ]; then
  715. error="ERROR: LA CONTRASEÑA NO PUEDE ESTAR VACIA.\n"
  716. elif [ $passwdMoodle != $passwdMoodle2 ];then
  717. error="ERROR: LAS CONTRASEÑAS NO COINCIDEN.\n"
  718. else
  719. control=true
  720. fi
  721. done
  722. unset control error passwdMoodle2 dominio cont serverName aliasMoodle
  723. }
  724. establecerFQDN() {
  725. while [ -z "$hostname" ]; do
  726. hostname=$(whiptail --title "FQDN" --inputbox "El nombre de dominio principal (FQDN) de este servidor es:\n"$(hostname)"\n\nQuieres cambiarlo por otro?" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Cambiar" --cancel-button "No Cambiar" 3>&1 1>&2 2>&3)
  727. if [ $? -eq 0 ] && [ ! -z "$hostname" ]; then
  728. hostnamectl set-hostname $hostname
  729. else
  730. hostname=$(hostname)
  731. fi
  732. done
  733. echo -en "Hostname: $hostname\n" >> $logFile
  734. }
  735. instalarApache() {
  736. if [ $debianOS = true ];then
  737. webServerName="apache2"
  738. result=$(apt-get -q -y install apache2 2>&1)
  739. comprobarError $? 101 $result
  740. elif [ $rhelOS = true ]; then
  741. webServerName="httpd"
  742. result=$(yum -y install httpd 2>&1)
  743. comprobarError $? 101 $result
  744. else
  745. comprobarError 1 104
  746. fi
  747. deshabilitarServicio $webServerName
  748. }
  749. configurarApache() {
  750. if [ $debianOS = true ];then
  751. apacheConfFile="./etc/apache2/apache2.conf"
  752. if [ ! -f $apacheConfFile ];then
  753. comprobarError 1 4 $apacheConfFile
  754. fi
  755. cp -f $apacheConfFile /etc/$webServerName/apache2.conf 2>/dev/null
  756. comprobarError $? 108
  757. webServerUser=$(grep ^User /etc/$webServerName/apache2.conf | cut -d ' ' -f 2)
  758. webServerGroup=$(grep ^Group /etc/$webServerName/apache2.conf | cut -d ' ' -f 2)
  759. if [ ! -L /etc/$webServerName/logs ];then
  760. ln -s /var/log/apache2 /etc/$webServerName/logs 2>/dev/null
  761. comprobarError $? 108
  762. fi
  763. # Activamos mod_rewrite (no viene activado por defecto)
  764. a2enmod rewrite >/dev/null 2>&1
  765. comprobarError $? 108
  766. elif [ $rhelOS = true ];then
  767. apacheConfFile="./etc/apache2/conf/httpd.conf"
  768. welcomeConfFile="/etc/apache2/conf.d/welcome.conf"
  769. if [ ! -f $apacheConfFile ];then
  770. comprobarError 1 4 $apacheConfFile
  771. fi
  772. cp -f $apacheConfFile /etc/$webServerName/conf/httpd.conf 2>/dev/null
  773. comprobarError $? 108
  774. if [ -f $welcomeConfFile ];then
  775. sed -i -e 's/^/#/' $welcomeConfFile
  776. comprobarError $? 108
  777. fi
  778. webServerUser=$(grep ^User /etc/$webServerName/conf/httpd.conf | cut -d ' ' -f 2)
  779. webServerGroup=$(grep ^Group /etc/$webServerName/conf/httpd.conf | cut -d ' ' -f 2)
  780. unset apacheConfFile welcomeConfFile
  781. fi
  782. if [ ! -d "/etc/$webServerName/sites-available" ];then
  783. mkdir "/etc/$webServerName/sites-available" 2>/dev/null
  784. comprobarError $? 5 "/etc/$webServerName/sites-available"
  785. fi
  786. if [ ! -d "/etc/$webServerName/sites-enabled" ]; then
  787. mkdir "/etc/$webServerName/sites-enabled" 2>/dev/null
  788. comprobarError $? 5 "/etc/$webServerName/sites-enabled"
  789. else
  790. # Eliminar Virtual Host por defecto
  791. if [ -f /etc/$webServerName/sites-enabled/000-default.conf ];then
  792. rm -f /etc/$webServerName/sites-enabled/000-default.conf 2>/dev/null
  793. fi
  794. fi
  795. }
  796. instalarNginx() {
  797. webServerName="nginx"
  798. if [ $debianOS = true ];then
  799. result=$(apt-get -q -y install nginx 2>&1)
  800. comprobarError $? 102 $result
  801. elif [ $rhelOS = true ]; then
  802. # Hay que instalar primero otro repositorio
  803. result=$(yum -y install epel-release)
  804. comprobarError $? 103 $result
  805. result=$(yum -y install nginx 2>&1)
  806. comprobarError $? 102 $result
  807. else
  808. comprobarError 1 105
  809. fi
  810. deshabilitarServicio $webServerName
  811. }
  812. configurarNginx() {
  813. # Configuramos Nginx
  814. rm -Rf /etc/$webServerName/* 2>/dev/null
  815. comprobarError $? 107
  816. nginxConfFile="./etc/$webServerName"
  817. if [ -d "$nginxConfFile" ];then
  818. cp -Rf $nginxConfFile/* /etc/$webServerName/ 2>/dev/null
  819. comprobarError $? 107
  820. else
  821. comprobarError 1 5 "$nginxConfFile"
  822. fi
  823. if [ ! -d "/etc/$webServerName/sites-available" ];then
  824. mkdir "/etc/$webServerName/sites-available" 2>/dev/null
  825. comprobarError $? 5 "/etc/$webServerName/sites-available"
  826. fi
  827. if [ ! -d "/etc/$webServerName/sites-enabled" ]; then
  828. mkdir "/etc/$webServerName/sites-enabled" 2>/dev/null
  829. comprobarError $? 5 "/etc/$webServerName/sites-enabled"
  830. fi
  831. # Configuramos Usuario y Grupo
  832. if [ $debianOS = true ];then
  833. webServerUser="www-data"
  834. webServerGroup=$webServerUser
  835. elif [ $rhelOS = true ];then
  836. webServerUser="nginx"
  837. webServerGroup=$webServerUser
  838. fi
  839. sed -i '/user /c\user '$webServerUser';' /etc/$webServerName/nginx.conf
  840. comprobarError $? 107
  841. unset nginxConfFile
  842. }
  843. instalarVirtualHost() {
  844. # Configuramos un Virtual Host para Apache o Nginx
  845. # Uso: instalarVirtualHost $root $virtualHost $dominio $alias
  846. if [ $# -ge 3 ];then
  847. rootVirtualHost=$(realpath $1)
  848. shift
  849. virtualHostFile=$(realpath $1)
  850. shift
  851. dominioVirtualHost=$1
  852. virtualHostName=$dominioVirtualHost".conf"
  853. shift
  854. aliasVirtualHost=$@
  855. else
  856. comprobarError 1 908
  857. fi
  858. if [ ! -f $virtualHostFile ];then
  859. comprobarError 1 909 $virtualHostName
  860. fi
  861. if [ $apacheOn = true ];then
  862. # Configuramos root, dominio y logs
  863. sed -i '/ServerName /c\\tServerName '"$dominioVirtualHost" $virtualHostFile
  864. comprobarError $? 908
  865. if [ ! -z "$aliasVirtualHost" ];then
  866. sed -i '/ServerName /a\\tServerAlias '"$aliasVirtualHost" $virtualHostFile
  867. comprobarError $? 908
  868. fi
  869. sed -i '/DocumentRoot /c\\tDocumentRoot '"$rootVirtualHost" $virtualHostFile
  870. comprobarError $? 908
  871. sed -i '/ErrorLog /c\\tErrorLog logs/'"$dominioVirtualHost"'-error.log' $virtualHostFile
  872. comprobarError $? 908
  873. sed -i '/CustomLog /c\\tCustomLog logs/'"$dominioVirtualHost"'-access.log common' $virtualHostFile
  874. comprobarError $? 908
  875. elif [ $nginxOn = true ];then
  876. # Configuramos root, dominio, logs y php-fpm.sock (NGINX)
  877. sed -i '/root /c\\troot '$rootVirtualHost';' "$virtualHostFile"
  878. comprobarError $? 908
  879. sed -i '/server_name /c\\tserver_name '"$dominioVirtualHost"' '"$aliasVirtualHost"';' $virtualHostFile
  880. comprobarError $? 908
  881. sed -i '/access_log /c\\taccess_log /var/log/nginx/'"$dominioVirtualHost"'-access.log;' $virtualHostFile
  882. comprobarError $? 908
  883. sed -i '/error_log /c\\terror_log /var/log/nginx/'"$dominioVirtualHost"'-error.log;' $virtualHostFile
  884. comprobarError $? 908
  885. socket=$(find /var/run/ -type s -name 'php*.sock')
  886. sed -i '/fastcgi_pass /c\\t\tfastcgi_pass unix:'"$socket"';' $virtualHostFile
  887. fi
  888. # Copiamos ficheros de configuración
  889. cp -f $virtualHostFile "/etc/$webServerName/sites-available/$virtualHostName" >> $logFile 2>&1
  890. comprobarError $? 910
  891. ln -s "/etc/$webServerName/sites-available/$virtualHostName" "/etc/$webServerName/sites-enabled/$virtualHostName" >> $logFile 2>&1
  892. comprobarError $? 911 $virtualHostName
  893. recargarServicio $webServerName
  894. unset rootVirtualHost dominioVirtualHost virtualHostFile virtualHostName aliasVirtualHost socket
  895. }
  896. mostrarDatabase() {
  897. if [ $debianOS = true ]; then
  898. database=$(whiptail --title "BASE DE DATOS" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge la base de datos que quieres usar:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) 2 \
  899. "MariaDB" "Instalar la base de datos MariaDB (fork de MySQL)" ON \
  900. "MySQL" "Instalar la base de datos MySQL (uso no comercial)" OFF \
  901. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  902. comprobarError $? 1
  903. case $database in
  904. MariaDB)
  905. mariaDBOn=true
  906. ;;
  907. MySQL)
  908. mySQLOn=true
  909. ;;
  910. *)
  911. comprobarError 1 200
  912. ;;
  913. esac
  914. unset database
  915. elif [ $rhelOS = true ]; then
  916. whiptail --title "BASE DE DATOS" --yesno "Para su distribucion $OS $DIST $REV, sólo está disponible la base de datos MariaDB." $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --yes-button "Continuar" --no-button "Salir"
  917. comprobarError $? 1
  918. mariaDBOn=true
  919. else
  920. comprobarError 1 200
  921. fi
  922. # Otras opciones (contraseña)
  923. leerSQLPasswd
  924. }
  925. leerSQLPasswd() {
  926. control=false
  927. error=""
  928. # Leemos la contreseña (stdin) y confirmamos
  929. while [ $control = false ]; do
  930. sqlPasswd=$(whiptail --title "CONTRASEÑA SQL" --passwordbox "$error""Introduzca la contraseña para el usuario 'root' de la base de datos:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Continuar" --nocancel 3>&1 1>&2 2>&3)
  931. comprobarError $? 1
  932. sqlPasswd2=$(whiptail --title "CONTRASEÑA SQL" --passwordbox "Confirme la contraseña:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Continuar" --nocancel 3>&1 1>&2 2>&3)
  933. comprobarError $? 1
  934. #echo -en "SQL Password 1: $sqlPasswd\n"
  935. #echo -en "SQL Password 2: $sqlPasswd2\n"
  936. if [ -z "$sqlPasswd" ] || [ -z "$sqlPasswd2" ]; then
  937. error="ERROR: LA CONTRASEÑA NO PUEDE ESTAR VACIA.\n"
  938. elif [ $sqlPasswd != $sqlPasswd2 ];then
  939. error="ERROR: LAS CONTRASEÑAS NO COINCIDEN.\n"
  940. else
  941. control=true
  942. fi
  943. done
  944. #echo -en "SQL Password: $sqlPasswd\n"
  945. unset control error sqlPasswd2
  946. }
  947. establecerSQLPasswd() {
  948. # Establecemos SQL root passwd y securizamos BD (mysql_secure_installation)
  949. # Comprobamos si ya tiene una contraseña asignada
  950. mysql -e "FLUSH PRIVILEGES" >> $logFile 2>&1
  951. if [ $? -eq 0 ];then
  952. # Establecemos contraseña del usuario root (y desactivamos posibles plugins para forzar login por contraseña)
  953. mysql -e "UPDATE mysql.user SET plugin = '', Password = PASSWORD('$sqlPasswd') WHERE User = 'root'" >> $logFile 2>&1
  954. if [ $? -ne 0 ];then
  955. # Lo intentamos de otra forma (para versiones modernas de mysql)
  956. mysql -e "ALTER USER 'root'@'localhost' IDENTIFIED WITH mysql_native_password BY '$sqlPasswd'" >> $logFile 2>&1
  957. comprobarError $? 207
  958. fi
  959. # Aplicamos el cambio de contraseña
  960. mysql -e "FLUSH PRIVILEGES" >> $logFile 2>&1
  961. # Desactivamos acceso root desde el exterior (solo localhost)
  962. mysql -u root --password=$sqlPasswd -e "DELETE FROM mysql.user WHERE User='root' AND Host NOT IN ('localhost', '127.0.0.1', '::1')" >> $logFile 2>&1
  963. comprobarError $? 208
  964. # Eliminamos todos los usuarios anónimos
  965. mysql -u root --password=$sqlPasswd -e "DELETE FROM mysql.user WHERE User=''" >> $logFile 2>&1
  966. comprobarError $? 209
  967. # Eliminamos bases de datos 'test'
  968. mysql -u root --password=$sqlPasswd -e "DROP DATABASE IF EXISTS test" >> $logFile 2>&1
  969. comprobarError $? 210
  970. # Eliminamos privilegios de la base de datos 'test'
  971. mysql -u root --password=$sqlPasswd -e "DELETE FROM mysql.db WHERE Db='test' OR Db='test\\_%'" >> $logFile 2>&1
  972. comprobarError $? 211
  973. # Aplicamos los cambios
  974. mysql -u root --password=$sqlPasswd -e "FLUSH PRIVILEGES" >> $logFile 2>&1
  975. comprobarError $? 212
  976. else
  977. comprobarError 1 206
  978. fi
  979. }
  980. instalarMySQL() {
  981. sqlServerName="mysql"
  982. if [ $debianOS = true ];then
  983. result=$(apt-get -q -y install mysql-server mysql-client 2>&1)
  984. comprobarError $? 201 $result
  985. elif [ $rhelOS = true ];then
  986. # MySQL no disponible en RHEL. 2 opciones:
  987. # 1) Instalar un repositorio adicional
  988. # 2) No instalar MySQL en distribuciones RHEL
  989. comprobarError 1 205
  990. else
  991. comprobarError 1 203
  992. fi
  993. deshabilitarServicio $sqlServerName
  994. }
  995. instalarMariaDB() {
  996. sqlServerName="mariadb"
  997. if [ $debianOS = true ];then
  998. result=$(apt-get -q -y install mariadb-server mariadb-client 2>&1)
  999. comprobarError $? 202 $result
  1000. elif [ $rhelOS = true ];then
  1001. result=$(yum -y install mariadb-server mariadb 2>&1)
  1002. comprobarError $? 202 $result
  1003. else
  1004. comprobarError 1 204
  1005. fi
  1006. deshabilitarServicio $sqlServerName
  1007. }
  1008. configurarSQL() {
  1009. # Configura MariaDB o MySQL
  1010. if [ $mariaDBOn = true ] && [ $debianOS = true ];then
  1011. sqlConfFile="/etc/mysql/my.cnf"
  1012. elif [ $mariaDBOn = true ] && [ $rhelOS = true ];then
  1013. sqlConfFile="/etc/my.cnf"
  1014. elif [ $mySQLOn = true ] && [ $debianOS = true ];then
  1015. sqlConfFile="/etc/mysql/my.cnf"
  1016. else
  1017. comprobarError 1 213
  1018. fi
  1019. if [ ! -f $sqlConfFile ];then
  1020. comprobarError 1 213
  1021. fi
  1022. grep "# Configuration for Moodle" $sqlConfFile >/dev/null 2>&1
  1023. if [ $? -ne 0 ];then
  1024. # Establecemos UTF8 (codificación de caracteres) y Barracuda (sistema de ficheros)
  1025. echo -en "\n# Configuration for Moodle\n" >> $sqlConfFile
  1026. echo -en "[client]\n" >> $sqlConfFile
  1027. echo -en "default-character-set = utf8mb4\n\n" >> $sqlConfFile
  1028. echo -en "[mysqld]\n" >> $sqlConfFile
  1029. echo -en "innodb_file_format = Barracuda\n" >> $sqlConfFile
  1030. echo -en "innodb_file_per_table = 1\n" >> $sqlConfFile
  1031. echo -en "innodb_large_prefix\n\n" >> $sqlConfFile
  1032. echo -en "character-set-server = utf8mb4\n" >> $sqlConfFile
  1033. echo -en "collation-server = utf8mb4_unicode_ci\n" >> $sqlConfFile
  1034. echo -en "skip-character-set-client-handshake\n\n" >> $sqlConfFile
  1035. echo -en "[mysql]\n" >> $sqlConfFile
  1036. echo -en "default-character-set = utf8mb4\n" >> $sqlConfFile
  1037. else
  1038. comprobarError 1 214
  1039. fi
  1040. unset sqlConfFile
  1041. }
  1042. instalarPHP() {
  1043. # Instalamos PHP-7 de forma diferente si es junto a Apache o con Nginx
  1044. if [ $debianOS = true ];then
  1045. if [ $apacheOn = true ]; then
  1046. result=$(apt-get -q -y install php libapache2-mod-php php-mysql php-intl php-mbstring php-xml php-apcu php-gd php-curl php-zip php-soap php-xmlrpc 2>&1)
  1047. comprobarError $? 302 $result
  1048. elif [ $nginxOn = true ];then
  1049. phpFPMName="php7.2-fpm"
  1050. result=$(apt-get -q -y install php-fpm php-mysql php-intl php-mbstring php-xml php-apcu php-gd php-curl php-zip php-soap php-xmlrpc 2>&1)
  1051. comprobarError $? 302 $result
  1052. deshabilitarServicio $phpFPMName
  1053. else
  1054. comprobarError 1 301
  1055. fi
  1056. elif [ $rhelOS = true ];then
  1057. # Necesitamos un repositorio adicional para PHP-7 (EPEL-RELEASE)
  1058. result=$(yum -y install epel-release yum-utils 2>&1)
  1059. comprobarError $? 103 $result
  1060. # Necesitamos un repositorio adicional para PHP-7 (REMI-RELEASE)
  1061. if [ ! -f /etc/yum.repos.d/remi-php72.repo ];then
  1062. if [ $VERSION = "7" ];then
  1063. result=$(yum -y install http://remi.mirrors.cu.be/enterprise/remi-release-7.rpm 2>&1)
  1064. comprobarError $? 303 $result
  1065. elif [ $VERSION = "6" ];then
  1066. result=$(yum -y install http://remi.mirrors.cu.be/enterprise/remi-release-6.rpm 2>&1)
  1067. comprobarError $? 303 $result
  1068. elif [ $VERSION = "28" ];then
  1069. result=$(yum -y install http://remi.mirrors.cu.be/fedora/remi-release-28.rpm 2>&1)
  1070. comprobarError $? 303 $result
  1071. elif [ $VERSION = "27" ];then
  1072. result=$(yum -y install http://remi.mirrors.cu.be/fedora/remi-release-27.rpm 2>&1)
  1073. comprobarError $? 303 $result
  1074. else
  1075. comprobarError 1 304
  1076. fi
  1077. fi
  1078. # Activamos repositorio remi-php72
  1079. result=$(yum-config-manager --enable remi-php72 2>&1)
  1080. comprobarError $? 303 $result
  1081. # Instalamos PHP-7.2
  1082. if [ $apacheOn = true ];then
  1083. result=$(yum -y install php php-mysql php-intl php-mbstring php-mcrypt php-xml php-pecl-apcu php-gd php-pear-Net-Curl php-pecl-zip php-soap php-xmlrpc 2>&1)
  1084. comprobarError $? 302 $result
  1085. elif [ $nginxOn = true ];then
  1086. phpFPMName="php-fpm"
  1087. result=$(yum -y install php php-fpm php-mysql php-intl php-mbstring php-mcrypt php-xml php-pecl-apcu php-gd php-pear-Net-Curl php-pecl-zip php-soap php-xmlrpc 2>&1)
  1088. comprobarError $? 302 $result
  1089. deshabilitarServicio $phpFPMName
  1090. else
  1091. comprobarError 1 301
  1092. fi
  1093. else
  1094. comprobarError 1 300
  1095. fi
  1096. }
  1097. configurarPHP() {
  1098. # Configura PHP para segurizarlo y establecer máximo de subida.
  1099. if [ $debianOS = true ];then
  1100. phpConfFile="./etc/php/php.ini.debian"
  1101. phpDest="/etc/php/7.2/cli/php.ini"
  1102. elif [ $rhelOS = true ];then
  1103. phpConfFile="./etc/php/php.ini.rhel"
  1104. phpDest="/etc/php.ini"
  1105. fi
  1106. if [ ! -f $phpConfFile ];then
  1107. comprobarError 1 4 "$phpConfFile"
  1108. fi
  1109. # Copiamos configuración
  1110. cp -f $phpConfFile $phpDest 2>/dev/null
  1111. comprobarError $? 305
  1112. # Configuramos cgi.fix_pathinfo
  1113. sed -i '/cgi.fix_pathinfo=/c\cgi.fix_pathinfo=0' $phpDest
  1114. comprobarError $? 305
  1115. # Configuramos post_max_size
  1116. sed -i '/post_max_size =/c\post_max_size = '$maxUpload $phpDest
  1117. comprobarError $? 305
  1118. # Configuramos upload_max_filesize
  1119. sed -i '/upload_max_filesize =/c\upload_max_filesize = '$maxUpload $phpDest
  1120. comprobarError $? 305
  1121. # Configurar php-fpm (sólo en RHEL con Nginx)
  1122. if [ $rhelOS = true ] && [ $nginxOn = true ];then
  1123. # Configurar Socket UNIX
  1124. phpConfFile="./etc/php/php-fpm.d/www.conf"
  1125. phpDest="/etc/php-fpm.d/www.conf"
  1126. if [ ! -f $phpConfFile ];then
  1127. comprobarError $? 4 "$phpConfFile"
  1128. fi
  1129. cp -f $phpConfFile $phpDest 2>/dev/null
  1130. comprobarError $? 305
  1131. # Configurar Permisos /var/lib/php
  1132. chown -R $webServerUser:$webServerGroup /var/lib/php/
  1133. comprobarError $? 305
  1134. fi
  1135. unset phpConfFile phpDest
  1136. }
  1137. establecerMaxUpload() {
  1138. control=false
  1139. error=""
  1140. while [ $control = false ];do
  1141. maxUpload2=$(whiptail --title "PHP MAX UPLOAD" --inputbox "$error""Introduzca el tamaño máximo permitido de los ficheros subidos al servidor:\n(<K:Kilobyte> <M:Megabyte> <G:Gigabyte>)" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) $maxUpload --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  1142. comprobarError $? 1
  1143. if [ -z "$maxUpload2" ];then
  1144. error="ERROR: NO PUEDES DEJAR ESTE PARÁMETRO VACIO.\n"
  1145. else
  1146. control=true
  1147. fi
  1148. done
  1149. maxUpload=$maxUpload2
  1150. unset control maxUpload2
  1151. }
  1152. instalarPHPInfo() {
  1153. # Instalar fichero php
  1154. if [ ! -f /etc/$webServerName/sites-enabled/phpinfo.conf ];then
  1155. infoFile="./var/www/info.php"
  1156. if [ ! -f $infoFile ];then
  1157. comprobarError 1 4 "$infoFile"
  1158. fi
  1159. mkdir /var/www/localhost 2>/dev/null
  1160. comprobarError $? 106
  1161. cp -f $infoFile /var/www/localhost/ 2>/dev/null
  1162. comprobarError $? 106
  1163. chown -R $webServerUser:$webServerGroup /var/www/localhost 2>/dev/null
  1164. comprobarError $? 106
  1165. unset infoFile
  1166. # Instalar VirtualHost
  1167. if [ $apacheOn = true ] && [ $sslOn = false ];then
  1168. virtualHost="./etc/apache2/sites-available/phpinfo.conf"
  1169. elif [ $nginxOn = true ] && [ $sslOn = false ];then
  1170. virtualHost="./etc/nginx/sites-available/phpinfo.conf"
  1171. elif [ $apacheOn = true ] && [ $sslOn = true ];then
  1172. virtualHost="./etc/apache2/sites-available/phpinfo-ssl.conf"
  1173. elif [ $nginxOn = true ] && [ $sslOn = true ];then
  1174. virtualHost="./etc/nginx/sites-available/phpinfo-ssl.conf"
  1175. else
  1176. comprobarError 1 106
  1177. fi
  1178. instalarVirtualHost "/var/www/localhost" $virtualHost "localhost"
  1179. unset virtualHost
  1180. return 0
  1181. else
  1182. return 1
  1183. fi
  1184. }
  1185. habilitarServicio() {
  1186. # Arrancamos y habilitamos el servicio (con SystemD, Upstart o SystemV)
  1187. # Intentamos con systemctl (SystemD)
  1188. #echo -en "Habilitando Servicio '$1'" | tee -a $logFile
  1189. if [ $# -le 0 ];then
  1190. comprobarError 1 900
  1191. fi
  1192. which systemctl > /dev/null 2>&1
  1193. if [ $? -eq 0 ]; then
  1194. #echo -en " (SystemD)..." | tee -a $logFile
  1195. systemctl start $1 > /dev/null 2>&1
  1196. comprobarError $? 901 $1
  1197. systemctl enable $1 > /dev/null 2>&1
  1198. comprobarError $? 902 $1
  1199. else
  1200. # Intentamos con service (Upstart)
  1201. which service > /dev/null 2>&1
  1202. if [ $? -eq 0 ]; then
  1203. #echo -en " (Upstart)..." | tee -a $logFile
  1204. service $1 start > /dev/null 2>&1
  1205. comprobarError $? 901 $1
  1206. else
  1207. # Intentamos con init.d (SystemV)
  1208. #echo -en " (SystemV)..." | tee -a $logFile
  1209. /etc/init.d/$1 start > /dev/null 2>&1
  1210. comprobarError $? 901 $1
  1211. fi
  1212. # Intentamos habilitar en el arranque (Upstart)
  1213. which update-rc.d > /dev/null 2>&1
  1214. if [ $? -eq 0 ];then
  1215. update-rc.d $1 enable
  1216. comprobarError $? 902 $1
  1217. else
  1218. # Intentamos habilitar en el arranque (SystemV)
  1219. which chkconfig > /dev/null 2>&1
  1220. if [ $? -eq 0 ];then
  1221. chkconfig $1 on
  1222. comprobarError $? 902 $1
  1223. else
  1224. # ¿Qué mas opciones nos quedan?
  1225. comprobarError 1 902 $1
  1226. fi
  1227. fi
  1228. fi
  1229. # Mejora: comprobar si el servicio está parado
  1230. #echo -en " OK.\n" | tee -a $logFile
  1231. }
  1232. deshabilitarServicio() {
  1233. # Paramos y deshabilitamos el servicio (con SystemD, Upstart o SystemV)
  1234. # Intentamos con systemctl (SystemD)
  1235. #echo -en "Deshabilitando Servicio '$1'" | tee -a $logFile
  1236. if [ $# -le 0 ];then
  1237. comprobarError 1 903
  1238. fi
  1239. which systemctl > /dev/null 2>&1
  1240. if [ $? -eq 0 ]; then
  1241. #echo -en " (SystemD)..." | tee -a $logFile
  1242. systemctl stop $1 > /dev/null 2>&1
  1243. comprobarError $? 904 $1
  1244. systemctl disable $1 > /dev/null 2>&1
  1245. comprobarError $? 905 $1
  1246. else
  1247. # Intentamos con service (Upstart)
  1248. which service > /dev/null 2>&1
  1249. if [ $? -eq 0 ]; then
  1250. #echo -en " (Upstart)..." | tee -a $logFile
  1251. service $1 stop > /dev/null 2>&1
  1252. comprobarError $? 904 $1
  1253. else
  1254. # Intentamos con init.d (SystemV)
  1255. #echo -en " (SystemV)..." | tee -a $logFile
  1256. /etc/init.d/$1 stop > /dev/null 2>&1
  1257. comprobarError $? 904 $1
  1258. fi
  1259. # Intentamos habilitar en el arranque (Upstart)
  1260. which update-rc.d > /dev/null 2>&1
  1261. if [ $? -eq 0 ];then
  1262. update-rc.d $1 disable
  1263. comprobarError $? 905 $1
  1264. else
  1265. # Intentamos habilitar en el arranque (SystemV)
  1266. which chkconfig > /dev/null 2>&1
  1267. if [ $? -eq 0 ];then
  1268. chkconfig $1 off
  1269. comprobarError $? 905 $1
  1270. else
  1271. # ¿Qué mas opciones nos quedan?
  1272. comprobarError 1 905 $1
  1273. fi
  1274. fi
  1275. fi
  1276. # Mejora: comprobar si el servicio está funcionando
  1277. #echo -en " OK.\n" | tee -a $logFile
  1278. }
  1279. recargarServicio() {
  1280. # Recargamos el servicio (con SystemD, Upstart o SystemV)
  1281. # Intentamos con systemctl (SystemD)
  1282. #echo -en "Recargando Servicio '$1'" | tee -a $logFile
  1283. if [ $# -le 0 ];then
  1284. comprobarError 1 912
  1285. fi
  1286. which systemctl > /dev/null 2>&1
  1287. if [ $? -eq 0 ]; then
  1288. #echo -en " (SystemD)..." | tee -a $logFile
  1289. systemctl reload $1 > /dev/null 2>&1
  1290. comprobarError $? 913 $1
  1291. else
  1292. # Intentamos con service (Upstart)
  1293. which service > /dev/null 2>&1
  1294. if [ $? -eq 0 ]; then
  1295. #echo -en " (Upstart)..." | tee -a $logFile
  1296. service $1 reload > /dev/null 2>&1
  1297. comprobarError $? 913 $1
  1298. else
  1299. # Intentamos con init.d (SystemV)
  1300. #echo -en " (SystemV)..." | tee -a $logFile
  1301. /etc/init.d/$1 reload > /dev/null 2>&1
  1302. comprobarError $? 913 $1
  1303. fi
  1304. fi
  1305. # Mejora: comprobar si el servicio está funcionando
  1306. #echo -en " OK.\n" | tee -a $logFile
  1307. }
  1308. configurarCortafuegos() {
  1309. # Configuramos cortafuegos (añadir reglas y encender)
  1310. # Comprobamos si estamos usando SSH
  1311. esSSH $PPID
  1312. if [ $debianOS = true ];then
  1313. ufw allow 80/tcp >> $logFile 2>&1
  1314. comprobarError $? 906 "80/tcp"
  1315. if [ $sshControl = true ];then
  1316. ufw allow 22/tcp >> $logFile 2>&1
  1317. comprobarError $? 906 "22/tcp"
  1318. fi
  1319. if [ $sslOn = true ];then
  1320. ufw allow 443/tcp >> $logFile 2>&1
  1321. comprobarError $? 906 "443/tcp"
  1322. fi
  1323. ufw --force enable >> $logFile 2>&1
  1324. comprobarError $? 907
  1325. elif [ $rhelOS = true ];then
  1326. firewall-cmd --add-port=80/tcp >> $logFile 2>&1
  1327. comprobarError $? 906 "80/tcp"
  1328. if [ $sshControl = true ];then
  1329. firewall-cmd --add-port=22/tcp >> $logFile 2>&1
  1330. comprobarError $? 906 "22/tcp"
  1331. fi
  1332. if [ $sslOn = true ];then
  1333. firewall-cmd --add-port=443/tcp >> $logFile 2>&1
  1334. comprobarError $? 906 "443/tcp"
  1335. fi
  1336. firewall-cmd --runtime-to-permanent >> $logFile 2>&1
  1337. comprobarError $? 907
  1338. habilitarServicio firewalld >> $logFile 2>&1
  1339. comprobarError $? 907
  1340. fi
  1341. unset sshControl
  1342. }
  1343. esSSH() {
  1344. p=${1:-$PPID}
  1345. #read pid name x ppid y < <( cat /proc/$p/stat )
  1346. read pid name ppid < <( ps -o pid= -o comm= -o ppid= -p $p)
  1347. [[ "$name" =~ sshd ]] && { sshControl=true; return 0; }
  1348. [ "$ppid" -le 1 ] && { sshControl=false; return 1; }
  1349. esSSH $ppid
  1350. }
  1351. descargarMediaWiki() {
  1352. # Descargar la versión 1.31.0 de MediaWiki
  1353. if [ ! -d ./var ];then
  1354. comprobarError 1 5 "./var"
  1355. fi
  1356. curl "https://releases.wikimedia.org/mediawiki/1.31/mediawiki-1.31.0.tar.gz" 2>/dev/null | tar -xz -C "./var/"
  1357. comprobarError $? 501
  1358. }
  1359. configurarMediaWiki() {
  1360. # Configuramos MediaWiki
  1361. if [ ! -f /var/www/$dominioMediaWiki/LocalSettings.php ];then
  1362. # Copiamos archivos
  1363. cp -fR ./var/mediawiki-1.31.0/ /var/www/$dominioMediaWiki
  1364. comprobarError $? 502
  1365. # Configuramos LocalSettings.php (y crea la base de datos por nosotros)
  1366. nombreDBMW=$(echo $dominioMediaWiki | sed -e 's/\./_/g')
  1367. userDBMW=$(echo $dominioMediaWiki | sed -e 's/\./_/g')
  1368. php /var/www/$dominioMediaWiki/maintenance/install.php --dbname=$nombreDBMW --dbserver="localhost" --installdbuser=root --installdbpass=$sqlPasswd --dbuser=$userDBMW --dbpass=$sqlPasswd --scriptpath="" --lang=es --pass=$passwdMediaWiki --with-extensions "$nombreMediaWiki" "admin" >> $logFile 2>&1
  1369. comprobarError $? 502
  1370. # Configuraciones adicionales
  1371. sed -i '/$wgLanguageCode =/c\$wgLanguageCode = "es";' /var/www/$dominioMediaWiki/LocalSettings.php
  1372. comprobarError $? 502
  1373. sed -i '/$wgEnableEmail =/c\$wgEnableEmail = false;' /var/www/$dominioMediaWiki/LocalSettings.php
  1374. comprobarError $? 502
  1375. sed -i '/$wgEnableUploads =/c\$wgEnableUploads = true;' /var/www/$dominioMediaWiki/LocalSettings.php
  1376. comprobarError $? 502
  1377. echo -en "\$wgArticlePath = \"/wiki/\$1\";\n" >> /var/www/$dominioMediaWiki/LocalSettings.php
  1378. echo -en "\$wgUsePathInfo = true;\n" >> /var/www/$dominioMediaWiki/LocalSettings.php
  1379. echo -en "\$wgGroupPermissions['*']['createaccount'] = true;\n" >> /var/www/$dominioMediaWiki/LocalSettings.php
  1380. echo -en "\$wgGroupPermissions['*']['edit'] = false;\n" >> /var/www/$dominioMediaWiki/LocalSettings.php
  1381. echo -en "\$wgGroupPermissions['*']['read'] = true;\n" >> /var/www/$dominioMediaWiki/LocalSettings.php
  1382. # Actualizamos permisos
  1383. chown -R $webServerUser:$webServerGroup /var/www/$dominioMediaWiki
  1384. comprobarError $? 502
  1385. # Configuramos VirtualHost
  1386. if [ $apacheOn = true ] && [ $sslOn = false ];then
  1387. virtualHost="./etc/apache2/sites-available/mediawiki.conf"
  1388. elif [ $nginxOn = true ] && [ $sslOn = false ];then
  1389. virtualHost="./etc/nginx/sites-available/mediawiki.conf"
  1390. elif [ $apacheOn = true ] && [ $sslOn = true ];then
  1391. virtualHost="./etc/apache2/sites-available/mediawiki-ssl.conf"
  1392. elif [ $nginxOn = true ] && [ $sslOn = true ];then
  1393. virtualHost="./etc/nginx/sites-available/mediawiki-ssl.conf"
  1394. else
  1395. comprobarError 1 502
  1396. fi
  1397. if [ ! -f $virtualHost ];then
  1398. comprobarError $? 502
  1399. fi
  1400. instalarVirtualHost "/var/www/$dominioMediaWiki" $virtualHost $dominioMediaWiki $aliasMediaWiki
  1401. unset virtualHost
  1402. else
  1403. comprobarError 1 503 $dominioMediaWiki
  1404. fi
  1405. }
  1406. descargarMoodle() {
  1407. # Descargar la versión 1.31.0 de MediaWiki
  1408. if [ ! -d ./var ];then
  1409. comprobarError 1 5 "./var"
  1410. fi
  1411. #echo -en "Descargando Moodle-3.5-1..." | tee -a $logFile
  1412. #curl -o "./var/moodle-3.5.1.tgz" "https://download.moodle.org/download.php/direct/stable35/moodle-latest-35.tgz" >> $logFile 2>&1
  1413. curl "https://download.moodle.org/download.php/direct/stable35/moodle-latest-35.tgz" 2>/dev/null | tar -xz -C "./var/"
  1414. comprobarError $? 501
  1415. #echo -en " OK.\n" | tee -a $logFile
  1416. }
  1417. configurarMoodle() {
  1418. # Configurar Moodle
  1419. if [ ! -f /var/www/$dominioMoodle/config.php ];then
  1420. # Copiamos archivos
  1421. cp -Rf ./var/moodle/ /var/www/$dominioMoodle
  1422. comprobarError $? 602
  1423. # Crear carperta de datos (no online)
  1424. if [ ! -d /var/www/moodledata ];then
  1425. mkdir /var/www/moodledata 2>/dev/null
  1426. comprobarError $? 602
  1427. #Actualizamos permisos
  1428. chmod -R 777 /var/www/moodledata 2>/dev/null
  1429. comprobarError $? 602
  1430. chown -R $webServerUser:$webServerGroup /var/www/moodledata 2>/dev/null
  1431. comprobarError $? 602
  1432. fi
  1433. # Creamos Base de Datos
  1434. nombreDBMo=$(echo $dominioMoodle | sed -e 's/\./_/g')
  1435. userDBMo=$(echo $dominioMoodle | sed -e 's/\./_/g')
  1436. crearDBMoodle
  1437. # Configurar SE-Linux (RHEL)
  1438. if [ $rhelOS = true ];then
  1439. configurarSELinux
  1440. fi
  1441. # Configuramos e instalamos Moodle
  1442. if [ $sslOn = true ];then
  1443. wwwroot="https://$dominioMoodle"
  1444. else
  1445. wwwroot="http://$dominioMoodle"
  1446. fi
  1447. if [ $mySQLOn = true ];then
  1448. dbtype="mysqli"
  1449. elif [ $mariaDBOn = true ];then
  1450. dbtype="mariadb"
  1451. else
  1452. comprobarError 1 602
  1453. fi
  1454. cd /var/www/$dominioMoodle
  1455. sudo -u $webServerUser php admin/cli/install.php --lang=es --wwwroot="$wwwroot" --dbtype="$dbtype" --dbname="$nombreDBMo" --dbuser="$userDBMo" --dbpass="$sqlPasswd" --fullname="$nombreMoodle" --shortname="$nombreCortoMoodle" --adminuser=admin --adminpass="$passwdMoodle" --adminemail="admin@$dominioMoodle" --agree-license --non-interactive >>$logFile 2>&1
  1456. comprobarError $? 602
  1457. cd - >/dev/null 2>&1
  1458. # Actualizamos permisos
  1459. chown -R $webServerUser:$webServerGroup /var/www/$dominioMoodle
  1460. # Configuramos VirtualHost
  1461. if [ $apacheOn = true ] && [ $sslOn = false ];then
  1462. virtualHost="./etc/apache2/sites-available/moodle.conf"
  1463. elif [ $nginxOn = true ] && [ $sslOn = false ];then
  1464. virtualHost="./etc/nginx/sites-available/moodle.conf"
  1465. elif [ $apacheOn = true ] && [ $sslOn = true ];then
  1466. virtualHost="./etc/apache2/sites-available/moodle-ssl.conf"
  1467. elif [ $nginxOn = true ] && [ $sslOn = true ];then
  1468. virtualHost="./etc/nginx/sites-available/moodle-ssl.conf"
  1469. else
  1470. comprobarError 1 602
  1471. fi
  1472. instalarVirtualHost "/var/www/$dominioMoodle" $virtualHost $dominioMoodle
  1473. unset virtualHost wwwroot dbtype
  1474. else
  1475. comprobarError 1 603 $dominioMoodle
  1476. fi
  1477. }
  1478. crearDBMoodle() {
  1479. # Creamos una base de datos para Moodle
  1480. dbDir="./etc/db"
  1481. if [ ! -d $dbDir ];then
  1482. mkdir $dbDir 2>/dev/null
  1483. comprobarError $? 503
  1484. fi
  1485. dbFile=$dbDir"/moodle.sql"
  1486. echo -en "CREATE DATABASE IF NOT EXISTS $nombreDBMo DEFAULT CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci;\n" > $dbFile
  1487. echo -en "GRANT ALL PRIVILEGES ON $nombreDBMo.* TO '$userDBMo'@'localhost' IDENTIFIED BY '$sqlPasswd';\n" >> $dbFile
  1488. mysql -u root --password=$sqlPasswd < $dbFile
  1489. control=$?
  1490. rm -f $dbFile 2>/dev/null
  1491. comprobarError $? 503
  1492. comprobarError $control 503
  1493. unset control dbFile dbDir
  1494. }
  1495. configurarSELinux() {
  1496. # Configura SELinux (Sólo para RHEL)
  1497. which semanage >/dev/null 2>&1
  1498. if [ $? -ne 0 ];then
  1499. result=$(yum -y install policycoreutils-python 2>&1)
  1500. comprobarError $? 605 $result
  1501. fi
  1502. semanage fcontext -a -t httpd_sys_rw_content_t "/var/www/moodledata(/.*)?" > /dev/null 2>&1
  1503. comprobarError $? 604
  1504. restorecon -R /var/www/ > /dev/null 2>&1
  1505. comprobarError $? 604
  1506. }
  1507. # Comprobación del sistema e inicialización
  1508. inicializarVariables
  1509. comprobarRoot
  1510. OSInfo
  1511. comprobarDependencias
  1512. # Bienvenida
  1513. mostrarBienvenida
  1514. # Selección de componentes (express vs avanzada)
  1515. mostrarExpress
  1516. # Instalación Servidor Web
  1517. if [ $apacheOn = true ]; then
  1518. echo -en "Instalando Servidor Web Apache..." | tee -a $logFile
  1519. # {
  1520. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1521. instalarApache
  1522. progreso=$((progreso + 1))
  1523. # } > >(whiptail --gauge "Instalando Web Server Apache..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1524. echo -en " OK.\n" | tee -a $logFile
  1525. elif [ $nginxOn = true ]; then
  1526. echo -en "Instalando Servidor Web Nginx..." | tee -a $logFile
  1527. # {
  1528. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1529. instalarNginx
  1530. progreso=$((progreso + 1))
  1531. # } > >(whiptail --gauge "Instalando Web Server Nginx..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1532. echo -en " OK.\n" | tee -a $logFile
  1533. fi
  1534. # Instalación Base de Datos
  1535. if [ $mySQLOn = true ]; then
  1536. echo -en "Instalando Base de Datos MySQL..." | tee -a $logFile
  1537. # {
  1538. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1539. instalarMySQL
  1540. progreso=$((progreso + 1))
  1541. # } > >(whiptail --gauge "Instalando Base de Datos MySQL..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1542. echo -en " OK.\n" | tee -a $logFile
  1543. elif [ $mariaDBOn = true ]; then
  1544. echo -en "Instalando Base de Datos MariaDB..." | tee -a $logFile
  1545. # {
  1546. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1547. instalarMariaDB
  1548. progreso=$((progreso + 1))
  1549. # } > >(whiptail --gauge "Instalando Base de Datos MariaDB..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1550. echo -en " OK.\n" | tee -a $logFile
  1551. fi
  1552. # Instalación PHP-7.2
  1553. if [ $phpOn = true ]; then
  1554. echo -en "Instalando PHP-7..." | tee -a $logFile
  1555. # {
  1556. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1557. instalarPHP
  1558. progreso=$((progreso + 1))
  1559. # } > >(whiptail --gauge "Instalando PHP-7..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1560. echo -en " OK.\n" | tee -a $logFile
  1561. fi
  1562. # Instalación SSL/TLS
  1563. if [ $sslOn = true ];then
  1564. echo -en "Instalando SSL/TLS..." | tee -a $logfile
  1565. # {
  1566. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1567. sleep 2
  1568. progreso=$((progreso + 1))
  1569. # } > >(whiptail --gauge "Instalando SSL/TLS..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1570. echo -en " OK.\n" | tee -a $logFile
  1571. fi
  1572. # Configuración Web Server
  1573. if [ $apacheOn = true ];then
  1574. echo -en "Configurando Servidor Web Apache..." | tee -a $logFile
  1575. # {
  1576. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1577. configurarApache
  1578. progreso=$((progreso + 1))
  1579. # } > >(whiptail --gauge "Configurando Servidor Web..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1580. echo -en " OK.\n" | tee -a $logFile
  1581. elif [ $nginxOn = true ]; then
  1582. echo -en "Configurando Servidor Web Nginx..." | tee -a $logFile
  1583. # {
  1584. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1585. configurarNginx
  1586. progreso=$((progreso + 1))
  1587. # } > >(whiptail --gauge "Configurando Servidor Web..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1588. echo -en " OK.\n" | tee -a $logFile
  1589. fi
  1590. # Configuración Database (Arrancar Base de Datos, establecer contraseña y configuración segura)
  1591. if [ $mySQLOn = true ] || [ $mariaDBOn = true ];then
  1592. echo -en "Configurando Base de Datos..." | tee -a $logFile
  1593. # {
  1594. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1595. configurarSQL
  1596. progreso=$((progreso + 1))
  1597. # } > >(whiptail --gauge "Configurando Base de Datos MySQL..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1598. echo -en " OK.\n" | tee -a $logFile
  1599. habilitarServicio "$sqlServerName"
  1600. echo -en "Estableciendo contraseña de la Base de Datos..." | tee -a $logFile
  1601. # {
  1602. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1603. establecerSQLPasswd
  1604. progreso=$((progreso + 1))
  1605. # } > >(whiptail --gauge "Configurando Base de Datos MySQL..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1606. echo -en " OK.\n" | tee -a $logFile
  1607. fi
  1608. # Configuración PHP (cgi.fix_pathinfo=0 y Configurar máximo de subida de archivos)
  1609. if [ $phpOn = true ];then
  1610. echo -en "Configurando PHP-7..." | tee -a $logFile
  1611. # {
  1612. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1613. configurarPHP
  1614. progreso=$((progreso + 1))
  1615. # } > >(whiptail --gauge "Configurando PHP-7..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1616. echo -en " OK.\n" | tee -a $logFile
  1617. fi
  1618. # Configuración SSL/TLS
  1619. # Generar certificados
  1620. # Configurar certificados
  1621. if [ $sslOn = true ];then
  1622. echo -en "Configurando SSL/TLS..." | tee -a $logFile
  1623. # {
  1624. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1625. sleep 2
  1626. progreso=$((progreso + 1))
  1627. # } > >(whiptail --gauge "Configurando SSL/TLS..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1628. echo -en " OK.\n" | tee -a $logFile
  1629. fi
  1630. # Arrancar y habilitar todos los servicios (SystemD, Service o SystemV)
  1631. echo -en "Habilitando todos los servicios..." | tee -a $logFile
  1632. # {
  1633. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1634. if [ $apacheOn = true ];then
  1635. habilitarServicio $webServerName
  1636. elif [ $nginxOn = true ];then
  1637. habilitarServicio $webServerName
  1638. if [ $phpOn = true ];then
  1639. habilitarServicio $phpFPMName
  1640. fi
  1641. fi
  1642. progreso=$((progreso + 1))
  1643. # } > >(whiptail --gauge "Arrancando Servicios..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1644. echo -en " OK.\n" | tee -a $logFile
  1645. # MediaWiki
  1646. if [ $mediaWikiOn = true ]; then
  1647. # Descargar MediaWiki
  1648. echo -en "Descargando MediaWiki-1.31.0..." | tee -a $logFile
  1649. # {
  1650. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1651. descargarMediaWiki
  1652. progreso=$((progreso + 1))
  1653. # } > >(whiptail --gauge "Instalando MediaWiki..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1654. echo -en " OK.\n" | tee -a $logFile
  1655. # Configurar MediWiki
  1656. echo -en "Configurando MediaWiki..." | tee -a $logFile
  1657. # {
  1658. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1659. configurarMediaWiki
  1660. progreso=$((progreso + 1))
  1661. # } > >(whiptail --gauge "Configurando MediaWiki..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1662. echo -en " OK.\n" | tee -a $logFile
  1663. fi
  1664. # Moodle
  1665. if [ $moodleOn = true ]; then
  1666. # Descargar Moodle
  1667. echo -en "Descargando Moodle-3.5.1..." | tee -a $logFile
  1668. # {
  1669. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1670. descargarMoodle
  1671. progreso=$((progreso + 1))
  1672. # } > >(whiptail --gauge "Instalando Moodle..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1673. echo -en " OK.\n" | tee -a $logFile
  1674. # Configuración Moodle
  1675. echo -en "Configurando Moodle..." | tee -a $logFile
  1676. # {
  1677. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1678. configurarMoodle
  1679. progreso=$((progreso + 1))
  1680. # } > >(whiptail --gauge "Configurando Moodle..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1681. echo -en " OK.\n" | tee -a $logFile
  1682. fi
  1683. # Configurar Virtual Hosts
  1684. # Instalar info.php
  1685. if [ $infoPHPOn = true ];then
  1686. echo -en "Configurando 'info.php'..." | tee -a $logFile
  1687. instalarPHPInfo
  1688. if [ $? -eq 0 ];then
  1689. echo -en " OK.\n" | tee -a $logFile
  1690. else
  1691. echo -en " Ya se encuentra configurado.\n" | tee -a $logFile
  1692. fi
  1693. fi
  1694. # Añadir reglas del cortafuegos
  1695. echo -en "Configurando Cortafuegos..." | tee -a $logFile
  1696. # {
  1697. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1698. configurarCortafuegos
  1699. progreso=$((progreso + 1))
  1700. # } > >(whiptail --gauge "Configurando Cortafuegos..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1701. echo -en " OK.\n" | tee -a $logFile
  1702. # Configurar actualizaciones
  1703. if [ $actualizacionesOn = true ]; then
  1704. echo -en "Configurando Actualizaciones Automáticas..." | tee -a $logFile
  1705. # {
  1706. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1707. sleep 2
  1708. progreso=$((progreso + 1))
  1709. # } > >(whiptail --gauge "Configurando actualizaciones automáticas..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1710. echo -en " OK.\n" | tee -a $logFile
  1711. fi